<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

if(!JComponentHelper::isEnabled('com_resource'))
{
	JError::raiseWarning(500, JText::_('Mighty Resources is not installed!'));
	return;
}

require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
ResControllerConfig::initialyze();

$loader = new ResPackInstaller();

//$loader->loadTable('users', 	'Res', 'users');

$loader->loadUsers();

$loader->loadTable('type', 		'Table', 'types');
$loader->loadTable('field', 	'Table', 'fields', 	array('type_id' => 'types'));
$loader->loadTable('filters', 	'Table', 'filters_ex');
$loader->loadTable('category', 	'Res', 'section');
$loader->loadTable('category', 	'Res', 'categories', array('parent' => 'categories', 'section_id' => 'section'));
$loader->loadTable('ucat', 		'Res', 'user_category', array('user_id' => 'users', 'section_id' => 'section'));
$loader->loadTable('record', 	'Res', 'records', 	array('user_id' => 'users', 'type_id' => 'types', 'ucatid' => 'user_category'));
$loader->loadTable('record_categories', 'Res', 'record_category', 	array('record_id' => 'records', 'catid' => 'categories'));
$loader->loadTable('comments', 	'Res', 'comments', 	array('user_id' => 'users', 'record_id' => 'records'));
$loader->loadTable('votes', 	'Res', 'votes', 	array('user_id' => 'users', 'record_id' => 'records'));
$loader->loadTable('favorites', 'Res', 'favorites', array('user_id' => 'users', 'record_id' => 'records'));
$loader->loadTable('record_values', 'Res', 'field_values', array('field_id' => 'fields', 'record_id' => 'records'));
$loader->loadTable('fieldExtra', 'Res', 'field_values_ex', array('user_id' => 'users', 'record_id' => 'records', 'field_id' => 'fields', 'field_value_id' => 'field_values'));
$loader->loadTable('tags', 'Table', 'tags');
$loader->loadTable('taghistory', 'Table', 'tag_history', array('record_id' => 'records', 'tag_id' => 'tags', 'user_id' => 'users', 'section_id' => 'section'));

$loader->moveFiles();
$loader->touchTemplates();
$loader->touchParams();

$loader->end();


class ResPackInstaller
{
	var $params = '';
	var $rand = '';
	var $ids = array();
	var $isNew = false;
	var $table = null;
	var $id = null;


	function touchParams()
	{
		$table = & JTable::getInstance('type', 'Table');

		foreach ($this->ids['types'] AS $old_id => $new_id)
		{
			if($table->load($new_id))
			{
				$params = new JParameter($table->params);
				$categories = $params->get('item_category_limit');
				settype($categories, 'array');
				JArrayHelper::toInteger($categories);
				$ids = array();
				foreach ($categories AS $id)
				{
					if(!$id) continue;
					if(!@$this->ids['categories'][$id]) continue;
					$ids[] = $this->ids['categories'][$id];
				}
				if($ids)
				{
					$table->params = str_replace("item_category_limit=".implode("|", $categories)."\n", "item_category_limit=".implode("|", $ids)."\n", $table->params);
					$table->store();
				}
			}
		}
		$table = & JTable::getInstance('category', 'Res');
		foreach ($this->ids['section'] AS $old_id => $new_id)
		{
			if($table->load($new_id))
			{
				$params = new JParameter($table->params);
				$types = $params->get('type');
				settype($types, 'array');
				JArrayHelper::toInteger($types);
				$ids = array();
				foreach ($types AS $id)
				{
					if(!$id) continue;
					if(@$this->ids['types'][$id]) $ids[] = $this->ids['types'][$id];
				}
				if(@$ids)
				{
					$table->params = str_replace("type=".implode("|", $types)."\n", "type=".implode("|", $ids)."\n", $table->params);
					$table->store();
				}
			}
		}

		$table = & JTable::getInstance('field', 'Table');
		foreach ($this->ids['fields'] AS $old_id => $new_id)
		{
			if($table->load($new_id))
			{
				$params = new JParameter($table->params);

				switch($table->type)
				{
					case 'records':
						if(@$this->ids['categories'][$params->get('r_sec_id')]) $table->params = str_replace("r_sec_id=".$params->get('r_sec_id')."\n", "r_sec_id=".$this->ids['categories'][$params->get('r_sec_id')]."\n", $table->params);
						if(@$this->ids['fields'][$params->get('r_field_id')]) $table->params = str_replace("r_field_id=".$params->get('r_field_id')."\n", "r_field_id=".$this->ids['fields'][$params->get('r_field_id')]."\n", $table->params);
					break;
					
					case 'relate_child2':
						if(@$this->ids['types'][$params->get('parent_type')]) $table->params = str_replace("parent_type=".$params->get('parent_type')."\n", "parent_type=".$this->ids['types'][$params->get('parent_type')]."\n", $table->params);
						$fields = $params->get('show_relate_field');
						settype($fields, 'array');
						$ids = array();
						foreach ($fields as $field)
						{
							if(@$this->ids['fields'][$field]) $ids[] = $this->ids['fields'][$field];
						}
						if($ids) $table->params = str_replace("show_relate_field=".implode("|", $params->get('show_relate_field'))."\n", "show_relate_field=".implode("|", $ids)."\n", $table->params);
					break;
					
					case 'relate_parent2':
						$table->params = str_replace("relate_field=".$params->get('relate_field')."\n", "relate_field=".$this->ids['fields'][$params->get('relate_field')]."\n", $table->params);
						$fields = $params->get('show_relate_field');
						settype($fields, 'array');
						$ids = array();
						foreach ($fields as $field)
						{
							if(@$this->ids['fields'][$field]) $ids[] = $this->ids['fields'][$field];
						}
						if($ids) $table->params = str_replace("show_relate_field=".implode("|", $params->get('show_relate_field'))."\n", "show_relate_field=".implode("|", $ids)."\n", $table->params);
					break;
				}

				$table->store();
				$table->reset();
			}
		}

	}
	function ResPackInstaller()
	{
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'tables');

		$this->params = $this->_getObject('params');
		$this->rand = $this->params->get('rand');

		define('RND_PATH', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'packs');
		if(!JFolder::exists(RND_PATH))
		{
			JFolder::create(RND_PATH);
		}
		if(!JFile::exists(RND_PATH.DS.$this->rand))
		{
			$this->isNew = true;
		}
		else
		{
			$ids = JFile::read(RND_PATH.DS.$this->rand);
			$this->ids = unserialize($ids);
		}

		//print_r($this->ids);
	}
	function moveFiles()
	{
		if(JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'files'.DS.'upload'))
		{
			$folders = JFolder::folders(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'files'.DS.'upload', null, true, true);
			foreach ($folders AS $folder)
			{
				$user_id = basename($folder);
				if(!preg_match("#^[0-9]*$#", $user_id)) continue;
				if(@$this->ids['users'][$user_id])
				{
					JFolder::copy($folder, dirname($folder).DS.$this->ids['users'][$user_id]);
					JFolder::delete($folder);
				}
			}
			
			$folders = JFolder::files(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'files'.DS.'upload', '^[0-9]*_.*$', true, true);
			foreach ($folders AS $folder)
			{
				$file = basename($folder);
				if(!preg_match("#^([0-9]*)_(.*)$#iU", $file, $matches)) continue;
				if(@$matches[1] && $matches[2])
				{
					if(@$this->ids['records'][$matches[1]])
					{
						JFile::copy($folder, dirname($folder).DS.$this->ids['records'][$matches[1]].'_'.$matches[2]);
						JFile::delete($folder);
					}
				}
			}

			JFolder::copy(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'files'.DS.'upload', RES_GENERAL_UPLOAD, null, TRUE);
		}
		
		if(JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'files'.DS.'external'))
		{
			JFolder::copy(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'files'.DS.'external', JPATH_ROOT, null, TRUE);
		}
		
		if(JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'files'.DS.'add'))
		{
			$folders = JFolder::folders(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'files'.DS.'add', null, true, true);
			foreach ($folders AS $folder)
			{
				$user_id = basename($folder);
				if(!preg_match("#^[0-9]*$#", $user_id)) continue;
				if(@$this->ids['users'][$user_id])
				{
					JFolder::copy($folder, dirname($folder).DS.$this->ids['users'][$user_id]);
					JFolder::delete($folder);
				}
			}
			
			JFolder::copy(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'files'.DS.'add', JPATH_ROOT, null, TRUE);
		}
	}

	/**
	 * This function touch templates in case it is custom templates for particular type.
	 *
	 * It replace all ID of directly called (by ID) field values to new assigned ID.
	 *
	 */
	function touchTemplates()
	{
		$files = array();

		$add = JFolder::files(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list', '(.*)'.$this->rand.'\.php', TRUE, true);
		if(is_array($add)) $files = array_merge($files, $add);

		$add = JFolder::files(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'article', '(.*)'.$this->rand.'\.php', TRUE, true);
		if(is_array($add)) $files = array_merge($files, $add);


		foreach ($files AS $file)
		{
			$content = JFile::read($file);
			foreach ($this->ids['fields'] AS $old_id => $new_id)
			{
				$content = str_replace("->fields[{$old_id}]", "->fields[{$new_id}]", $content);
			}
			JFile::write($file, $content);
		}


		/**
		 * Now we need to change all template parameters that refered to
		 * fields. The rule for that was that all parameters which refer to
		 * field should have 'field_' phrase inside.
		 */
		$ini = JFolder::files(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views', '(.*)'.$this->rand.'\.ini', TRUE, true);
		foreach ($ini as $file)
		{
			$params = new JParameter(JFile::read($file));
			$paramsArray = $params->toArray();
			foreach($paramsArray AS $key => $val)
			{
				if (strlen(stristr($key, 'field_')) > 0)
				{
					$params->set($key, $this->ids['fields'][$val]);
				}
			}
			JFile::write($file, $params->toString());
		}
	}
	function end()
	{
		JFile::write(RND_PATH.DS.$this->rand, serialize($this->ids));
		if(JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'pack'))
		{
			JFolder::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'pack');
		}
		if(JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'files'))
		{
			JFolder::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'files');
		}
		//print_r($this->ids);
	}

	function loadUsers()
	{
		$users = $this->_getObject('users');
		$db = &JFactory::getDBO();
		

		foreach ($users as $user)
		{
			if($this->params->get('authors', 1) == 0)
			{
				$this->ids['users'][$user->id] = $this->params->get('special_author', 62);
				continue;
			}
			if($this->isNew)
			{
				$id = NULL;
			}
			else
			{
				if(@$this->ids['users'][$user->id])
				{
					$id = $this->ids['users'][$user->id];
				}
				else
				{
					$id = NULL;
				}
			}
			if($id == NULL)
			{
				$sql = "SELECT id FROM #__users WHERE username = {$user->username}";
				$db->setQuery($sql);
				$is_name = $db->loadResult();

				if($is_name)
				{
					$user->username .= '_new';
				}
			}

			$old_id = $user->id;
			$user->id = $id;
			$table = & JTable::getInstance('users', 'Res');
			$table->reset();
			if($user->id) $table->load($user->id);
			$table->bind($user, ($id ? array('username') : ''));
			$table->store();

			$this->ids['users'][$old_id] = $table->id;

			$sql = "SELECT id FROM #__core_acl_aro WHERE value = {$table->id}";
			$db->setQuery($sql);
			$aro_id = $db->loadResult();

			if(!$aro_id)
			{
				$sql = "INSERT INTO #__core_acl_aro VALUES (NULL, 'users', {$table->id}, 0, '{$user->username}', 0)";
				$db->setQuery($sql);
				$db->query();
				$aro_id = $db->insertid();
			}

			$sql = "SELECT group_id FROM #__core_acl_groups_aro_map WHERE aro_id = {$aro_id}";
			$db->setQuery($sql);
			$aro_map_id = $db->loadResult();

			if(!$aro_map_id)
			{
				$sql = "INSERT INTO #__core_acl_groups_aro_map VALUES (18, '', {$aro_id})";
				$db->setQuery($sql);
				$db->query();
			}
		}
	}

	Function loadTable($name, $prefix, $file, $keys = array())
	{
		$content = $this->_getObject($file);

		foreach ($content as $row) {
			$table = & JTable::getInstance($name, $prefix);
			$id = @$row->id;

			if(@$this->ids[$file][$id] && !$this->isNew)
			{
				$row->id = $this->ids[$file][$id];
				if(!$table->load($row->id))
				{
					$table->id = NULL;
					$row->id = NULL;
				}
			}
			else
			{
				$row->id = NULL;
			}

			if($file == 'tags')
			{
				$db = &JFactory::getDBO();
				$sql = "SELECT id FROM #__js_res_tags WHERE LOWER(`tag`) = '".JString::strtolower($row->tag)."'";
				$db->setQuery($sql);
				$tid = $db->loadResult();
				if($tid)
				{
					$row->id = $tid;
					$table->id = $tid;
				}
			}

			foreach($keys as $k => $v)
			{
				if($k == 'user_id')
				{
					if($this->params->get('authors', 1))
					{
						$val = (@$this->ids['users'][$row->$k] ? $this->ids['users'][$row->$k] : $this->params->get('special_author', 62));
					}
					else
					{
						$val = $this->params->get('special_author', 62);
					}
				}
				else
				{
					$val = @$this->ids[$v][$row->$k];
				}
				$row->$k = $val;
			}
			
			$table->reset();
			$table->bind($row);
			$table->store();

			if(@$table->id) $this->ids[$file][$id] = $table->id;

			if($file == 'section')
			{
				$this->ids['categories'][$id] = $table->id;
			}
		}

		unset($content);
	}

	function loadTags()
	{
		$tags 	= $this->_getObject('tags');
	}
	function _getObject($name)
	{
		$file = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'pack'.DS.$name.'.txt';
		if(!JFile::exists($file)) return array();
		$content = JFile::read($file);
		$content = unserialize($content);
		return $content;
	}
}
?>